double cluster_mesh_estimate1(POINT *parent, POINT *point, double *error){
  double *from, *to, *center;
  int max1, i;
  double S1, S2, S7, S8, S9 ,S10, S11, S12, S13, w, f, g, G,
    maxPrice, beta, S14, S15, S16, S17;
  POINT *this;

  S1 = 0;
  S2 = 0;
  S7 = 0;
  S8 = 0;
  S9 = 0;
  S10 = 0;
  S11 = 0;
  S12 = 0;
  S13 = 0;
  S14 = 0;
  S15 = 0;
  S16 = 0;
  S17 = 0.0;

  /* At the given time find the max prices */

  max1 = dWhichMax(Dimensions, point->price);

  G = exp(-point->timeslice*Interest_rate)*
    euroCall(point->price[max1], Strike_price, Interest_rate,
	     sqrt(Covariance[max1][max1]),1.0, Dividend_rate[max1]);

  from = point->price;
  center = parent->price;

  /* Loop over children in parent (cluster) */  
  for(i=0;i<parent->children.elements; i++){
    /* get the probability of going from point to point i in cluster */
    this = &(Time[parent->timeslice+1].element[parent->children.element[i]]);
    to = this->price;

    w = (1/(double)parent->children.elements)*transition_probability(from, to) / 
      transition_probability(center,to);

    /* value */
    f = this->value;
    maxPrice = this->price[max1];
    if(maxPrice > Strike_price){	
      g = exp(-this->timeslice*Interest_rate)*(maxPrice - Strike_price);
    }else{
      g= 0;
    }

    S1 += w;
    S2 += w*w;
    S7 += w*f;
    S8 += w*(g-G);
    S9 += w*w*f;
    S10 += w*w*(g-G);
    S11 += w*w*f*f;
    S12 += w*w*f*(g-G);
    S13 += w*w*(g-G)*(g-G);
    S14 += w*f*(g-G);
    S15 += w*(g-G)*(g-G);
    S16 += w*f*f;
    S17 += w * g;
  }

  /* Old derivation */
  /*   beta = ((S14/S1) - (S7/S1)*(S8/S1))/   */
  /*     ((S15/S1) - (S8/S1)*(S8/S1));   */


  /*   *error = sqrt(S16/S1 - (S7/S1)*(S7/S1)      */
  /* 		-2*beta*(S14/S1 - (S7/S1)*(S8/S1))      */
  /* 		+beta*beta*((S15/S1) - (S8/S1)*(S8/S1)));     */


  /* If beta blows up, return uncontrolled value and error */
  /*   if((S15/S1) - (S8/S1)*(S8/S1) == 0){ */
  /*     *error = sqrt((1/(S1*S1))*(S11 - 2*S7/S1*S9 + (S7/S1)*(S7/S1)*S2)); */
  /*     return(S7/S1); */

  /*   } */

  /* New derivation */
  if(fabs(S13/S1 - 2*S8*S10/(S1*S1) + S2*S8*S8/(S1*S1*S1)) < SMALLVAL){
    *error = ((1/(S1*S1))*(S11 - 2*S7/S1*S9 + (S7/S1)*(S7/S1)*S2));
    *error = sqrt(fabs(*error));
    return(S7/S1);
  }

  beta = (S12/S1 - (S8*S9 + S7*S10)/(S1*S1) + S2*S7*S8/(S1*S1*S1))/
    (S13/S1 - 2*S8*S10/(S1*S1) + S2*S8*S8/(S1*S1*S1));



  *error = 1/(S1*S1)*((S11 -2*beta*S12 + beta*beta*S13)  
		      -(2/S1)*(S7-beta*S8)*(S9-beta*S10) 
		      +(S2/(S1*S1))*(S7*S7 -2*beta*S7*S8 +beta*beta*S8*S8) );
  if(*error < SMALLVAL){
    *error = 0.0;
  }else{
    *error = sqrt(*error);
  }  
  if (fabs(S1)<SMALLVAL) {
    printf("BUG\n");
  }
  return( (S7-beta*S8)/S1);
} /* end cluster_mesh_estimate1 */



